//
//  Copyright 1998, Colosseum Builders, Inc. All Rights Reserved.
//
//  info@colosseumbuilder.com
//
//  This software is provided AS-IS. There is no warranty of *ANY* kind.
//  USE AT YOUR OWN RISK.
//
//

//
//  This is an Icon Tray application that can be used to immediately kill
//  any application.
//
//  Author:  John M. Miano  miano@colosseumbuilders.com
//
//  Version: 1.0
//
//  Date:  04-February-1998
//
//  Usage:
//
//    Run this application. You may included it in your system startup. To
//    kill a program double click on the icon in the tray to display a list
//    of running processes. Select the one you want to kill and click on the
//    "Kill" button. Be careful, killing KERNEL32 is not usually a good idea
//    but if you need to kill it this application will do the job.
//

#include <vcl\vcl.h>
#include <shellapi.h>
#pragma hdrstop

#include "FrmMain.h"
#include "FrmProcess.h"

//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TMainForm::AddTrayIcon ()
{
  // This function adds an icon to the tray.

  // Initialize the structure for Sell_NotifyIcon
  NOTIFYICONDATA icondata ;
  memset (&icondata, 0, sizeof (icondata)) ;
  icondata.cbSize = sizeof (icondata) ;

  icondata.hWnd = Handle ;  // Handle of the window to receive notification
  // Set up the Tip displayed when the mouse of over the icon.
  strncpy (icondata.szTip, "Process Killer", sizeof (icondata.szTip)) ;
  // Use the application's icon for the tray.
  icondata.hIcon = Application->Icon->Handle ;
  // Tell the shell the value to use for the notification message.
  icondata.uCallbackMessage = iconmessage ;
  // Tell what we are modifying (everything in this case).
  icondata.uFlags = NIF_MESSAGE | NIF_ICON | NIF_TIP ;
  // Add the icon.
  Shell_NotifyIcon (NIM_ADD, &icondata) ;
  return ;
}
void TMainForm::RemoveTrayIcon ()
{
  // This function removes the icon from the tray.
  NOTIFYICONDATA icondata ;
  memset (&icondata, 0, sizeof (icondata)) ;
  icondata.cbSize = sizeof (icondata) ;

  icondata.hWnd = Handle ;
  Shell_NotifyIcon (NIM_DELETE, &icondata) ;
  return ;
}

void __fastcall TMainForm::WndProc(Messages::TMessage &Message)
{
  // If the window receives a notification message from the shell then
  // pass it to the ProcessIconMessage function. Otherwise let the default
  // processing for the message take place.
  if (Message.Msg == iconmessage)
  {
    if (Message.LParam == WM_LBUTTONDBLCLK)
    {
      ProcessForm->Refresh () ;
      ProcessForm->Show () ;
    }
    return ;
  }
  TForm::WndProc (Message) ;
  return ;
}

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
  // Create a unique message number.
  iconmessage = RegisterWindowMessage ("IconNotify") ;

  AddTrayIcon () ;
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
  RemoveTrayIcon () ;
  return ;
}
//---------------------------------------------------------------------------
