//
//  Copyright 1998, Colosseum Builders, Inc. All Rights Reserved.
//
//  info@colosseumbuilder.com
//
//  This software is provided AS-IS. There is no warranty of *ANY* kind.
//  USE AT YOUR OWN RISK.
//
//

//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <tlhelp32.h>

#include <stdio.h>
#pragma hdrstop

#include "FrmProcess.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TProcessForm *ProcessForm;
//---------------------------------------------------------------------------
__fastcall TProcessForm::TProcessForm(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void TProcessForm::Refresh ()
{
  // This function places the process ID, parent process ID, and EXE file
  // name for each process in a separate column.

  ProcessList->Items->Clear () ;
  // Find each process and display it.
  HANDLE snapshot ;
  PROCESSENTRY32 processinfo ;
  processinfo.dwSize = sizeof (processinfo) ;
  snapshot = CreateToolhelp32Snapshot (TH32CS_SNAPPROCESS, 0) ;
  if (snapshot == NULL)
    return ;

  bool status = Process32First (snapshot, &processinfo) ;
  while (status)
  {
    TListItem *li = ProcessList->Items->Add () ;

    li->Data = (void *) processinfo.th32ProcessID ;

    String buffer ;
    int length ;
    buffer.SetLength (512) ;
    length = sprintf (buffer.c_str (), "%08X", processinfo.th32ProcessID) ;
    buffer.SetLength (length) ;
    li->Caption = buffer;

    buffer.SetLength (512) ;
    length = sprintf (buffer.c_str (), "%08X", processinfo.th32ParentProcessID) ;
    buffer.SetLength (length) ;
    li->SubItems->Add (buffer) ;

    li->SubItems->Add (processinfo.szExeFile) ;

    status = Process32Next (snapshot, &processinfo) ;
  }
  return ;
}
void __fastcall TProcessForm::ProcessListColumnClick(TObject *Sender,
      TListColumn *Column)
{
  // This function is called by clicking on one of the headers in the ListView
  // control. We make that a request to sort using the column as a key.
  sort_index = Column->Index ;
  ProcessList->AlphaSort () ;
  return ;
}
//---------------------------------------------------------------------------
void __fastcall TProcessForm::ProcessListCompare(TObject *Sender,
      TListItem *Item1, TListItem *Item2, int Data, int &Compare)
{
  String v1 ;
  String v2 ;
  if (sort_index == 0)
  {
    v1 = Item1->Caption ;
    v2 = Item2->Caption ;
  }
  else
  {
    v1 = Item1->SubItems->Strings [sort_index - 1] ;
    v2 = Item2->SubItems->Strings [sort_index - 1] ;
  }
  if (v1 < v2)
     Compare = -1 ;
  else if (v1 == v2)
    Compare = 0 ;
  else
    Compare = 1 ;
  return ;
}
//---------------------------------------------------------------------------

void __fastcall TProcessForm::RefreshButtonClick(TObject *Sender)
{
  Refresh () ;
  return ;
}
//---------------------------------------------------------------------------


void __fastcall TProcessForm::KillButtonClick(TObject *Sender)
{
  if (ProcessList->Selected == NULL)
    return ;

  DWORD pid = (DWORD) ProcessList->Selected->Data ;
  HANDLE process = OpenProcess (PROCESS_ALL_ACCESS, false, pid) ;

  TerminateProcess (process, -1) ;
  CloseHandle (process) ;
  // We have an extra refresh to add a delay to allow the deleted process
  // to be removed from the list.
  Refresh () ;
  Application->ProcessMessages () ;
  Refresh () ;
  return ;
}
//---------------------------------------------------------------------------

void __fastcall TProcessForm::CloseButtonClick(TObject *Sender)
{
  Hide () ;
  return ;
}
//---------------------------------------------------------------------------

